require "stringutil"

local function doResidental ( data, capacity )
	local ruleCapacity = math.floor(capacity / 4 + 0.5)
	if (ruleCapacity > 0) then
		data.stocks = {}
		data.stockRules = {}
		local cargoTypes = {"MAIL"}
		local inputs = { { { 1, } },  }
		
		for i = 1, 1 do
			data.stocks[i] = {
				cargoType = cargoTypes[i],
				type = "RECEIVING",
				edges = { },
				moreCapacity = ruleCapacity
			}
			data.stockRules[i] = {
				input = inputs[i],
				output = { { 0, } },
				capacity = ruleCapacity
			}
		end
	end			

	return data
end

local function constructionHandler (fileName, data)
	local fn = data.updateFn

	data.updateFn = function(params)
		local ole_landUseType = params.landUseType or -1
		result = fn(params)
		if ((string.ends( fileName, "ole_townbuilding.con") or string.ends( fileName, "ole_townbuilding_no_collision.con")) and (ole_landUseType == 0)) then
			return doResidental (result, result.personCapacity.capacity)
		elseif (data.type == "TOWN_BUILDING" and (data.townBuildingParams.landUseType == "RESIDENTIAL")) then
			result = doResidental (result, params.capacity)
			result.cost = 1000
			result.bulldozeCost = 100
		end
	end

	return result
end

function data()
return {
	info = {
	minorVersion = 1,
	severityAdd = "WARNING",
	severityRemove = "CRITICAL",
	name = _("TPF-Addon-Industrie_-_PostMod"),
	description = _("desc_mod"),
	tags = { "Industry", "Mail", "Script Mod", "Cargo" },
	authors = {
		{
			name = "nown",
			role = "CREATOR",
			text = "",
			steamProfile = "",
			tfnetId = ""
		},

	},
	visible = true
},
	runFn = function (settings)
		-- Modifier installieren
		addModifier( "loadConstruction", constructionHandler )
		
		-- neue Güterarten registrieren
		table.insert(game.config.cargotypes, { id = "MAIL",					name = _("mail"),					weight = 600 } )
		table.insert(game.config.cargotypes, { id = "UNSORTED_MAIL",		name = _("unsorted_mail"),			weight = 600 } )
		
		-- Industriebutton aktivieren (ermöglicht dem User das Setzen von Industrien)
		game.config.industryButton = true
	end,
}
end